function [ F ] = bethe( theta, W, oneMargs, twoMargs )
%F = bethe(theta, W, oneMargs, twoMargs)
%   Compute Bethe free energy given marginals

    fudge = 1e-6;

    [iVec, jVec, wVec] = findUT(W);    
    W = triu(W, 1) + triu(W, 1)';
    
    % Remember, entropy is NEGATIVE p log p!
    
    posProbs = squeeze(twoMargs(2,2,:));
    linMarg  = twoMargs(:);
    
%    assert(all(linMarg > -fudge), sprintf('linMarg was too negative: %g', linMarg));
    if any(linMarg < -fudge)
%        warning(['linMarg was too negative: ' num2str(linMarg(:))]);
    end
    linMarg(linMarg < 0) = 0;

    twoNz    = linMarg(linMarg ~= 0);
    twoS     = -sum(twoNz .* log(twoNz));
    twoF     = -sum(wVec .* posProbs) - twoS;
    
    degMin     = full(sum(W ~= 0, 2)) - 1;    
    linOneMarg = [oneMargs, 1 - oneMargs];

%    assert(all(vec(linOneMarg) > -fudge), 'linMarg was too negative');
    linOneMarg(linOneMarg < 0) = 0;
    if any(linMarg < -fudge)
%        warning(['linMarg was too negative: ' num2str(linOneMarg(:))]);
    end
    
    % This fixes up our code so that 0 * log(0) == 1 * log(1) == 0.
    linOneMarg(linOneMarg == 0) = 1;
    oneS       = -sum(linOneMarg .* log(linOneMarg), 2);
    oneF       = -sum(theta .* oneMargs) + sum(degMin .* oneS);
    
    F = oneF + twoF;    
end

