function plotDDMargHist(hist, addLegend)
% plotDDMargHist  Plot dual decomposition iterations. Does not add title.

    if nargin < 2
        addLegend = true;
    end

    T = length(hist);
    assert(mod(T, 2) == 0, 'T must be even');
    nIters = T / 2;
    
    % Odds are actual iterates; evens are averaged.
    odds  = 1:2:T;
    evens = 2:2:T;

    iterPrimals = [hist(odds).primal];
    iterDuals   = [hist(odds).dual];
    
    avgPrimals  = [hist(evens).primal];
    avgDuals    = [hist(evens).dual];
    
    xs = 1:nIters;
    plot(xs, iterPrimals, '-b', ...
         xs, avgPrimals,  '--b', ...
         xs, iterDuals,   '-r', ...
         xs, avgDuals,    '--r');
    
    if addLegend
        legend('Iter Primal', 'Avg Primal', 'Iter Dual', 'Avg Dual', 'Location', 'Best');
    end
    xlabel('Iter');
    ylabel('F_B');
    
end

