classdef MargBetheExtGrad < MargBetheFrankWolfe
% TODO: ADD SEMAPHORES!
% Idea: Extra (mixin) class which handles semaphore stuff and wraps
% solveSubLP. (Everything that uses Gurobi could use the semaphore stuff.)

    properties
        preModel     
        params = struct('OutputFlag', 0);
        sem
    end
    
    methods
        
        function this = MargBetheExtGrad(theta, W)
            this = this@MargBetheFrankWolfe(theta, W);
            
            [nConstr, nExtremes]   = size(this.extremes);
            this.preModel.A     = sparse([this.extremes ; ones(1, nExtremes)]);
            this.preModel.sense = repmat('=', nConstr + 1, 1);
            this.preModel.rhs   = [zeros(nConstr, 1) ; 1];
            this.preModel.obj   = [zeros(nExtremes, 1) ; 1];
            % Enforce upper bound on the mixture variables; unbounded scale
            % variable.
            this.preModel.ub    = [ones(nExtremes, 1) ; Inf];
            this.preModel.modelsense = 'max';
        end
        
        function target = solveSubLP(this, g)
            model = this.preModel;
            
            lastCol = [-g ; 0];            
            model.A = [model.A lastCol];
            model.rhs(1:end-1) = this.mu;
            
%             result = gurobi(model, this.params);
            result = gurobi(model);
            assert(strcmp(result.status, 'OPTIMAL'), 'solveSubLP not solved to optimality!');

            % The last variable was t.
            tMax = result.x(end);
            target = tMax * g;
        end
    end
    
end

