function model = augmentExtGrad(preModel, g)
% augmentExtGrad  Augment a Gurobi LP to solve the ExtGrad problem

    model = preModel;
    [oldRows, oldCols] = size(model.A);
    N = length(g);
    model.A = [ model.A zeros(oldRows, 1) ; eye(N) -g ];
    model.sense(end+1:end+N) = '=';
    model.rhs(end+1:end+N)   = 0;

    model.obj = zeros(oldCols + 1, 1);
    model.obj(end) = 1;
    
    model.modelsense = 'max';
    
end

