function [ thetaOvercomplete ] = biasedToOvercomplete(theta, W)
% biasedToOvercomplete  Convert biased parameters to overcomplete ones.
%
%   thetaOvercomplete = biasedToOvercomplete(theta, W). Should ONLY be used
%   for parameters, not mu.

    N = length(theta);
    
    thetaOne(2,N) = 0;
    thetaOne(2,:) = theta(:)';
    
    [~, ~, wVec] = findUT(W);
    nEdges = length(wVec);
    thetaTwo(2,2,nEdges) = 0;
    thetaTwo(2,2,:) = wVec;
    
    thetaOvercomplete = packOvercomplete(thetaOne, thetaTwo);

end

