function [cyc, Nconstr] = cycleChordlessCycle(N)
% [cyc, Nconstrs] = cycleChordlessCycle(N) compute cyc structure for C_N.

    % There just one chordless cycle, N.
    Cedges(N, 2) = 0;
    
    for i = 1:(N-1)
        Cedges(i,1) = i;
        Cedges(i,2) = i + 1;
    end
    
    % Final edge must be written in i < j order.
    Cedges(N, 1) = 1;
    Cedges(N, 2) = N;
        
    
    % Iterate through all odd numbers
    idx = 1;
    for k = 1:2:N
        % Each row of subsets indexes rows of Cedges we wish to put into
        % F(idx).edges.
        subsets = combnk(1:N, k);        
        Nsub    = size(subsets, 1);
        
        for ns = 1:Nsub
            idxs     = subsets(ns,:);
            compIdxs = 1:N;
            compIdxs(idxs) = [];
            
            edges     = Cedges(idxs,:);
            compEdges = Cedges(compIdxs,:);
            
            F(idx) = var2struct(idx, edges, compEdges);
            
            idx = idx + 1;
        end
    end
    
    cyc.edges = Cedges;
    cyc.F     = F;
    
    Nconstr = idx - 1;
end

