function g = gradBetheOvercomplete(mu, theta, degs, N, nEdges)
% betheOvercomplete  Evaluate gradient of BFE in overcomplete form.

    [thetaOne, thetaTwo] = unpackOvercomplete(theta, N, nEdges);
    [muOne, muTwo]       = unpackOvercomplete(mu, N, nEdges);

    gradOne = -thetaOne - bsxfun(@times, degs(:)' - 1, log(muOne) + 1);
    gradTwo = -thetaTwo + log(muTwo) + 1;
    
    g = packOvercomplete(gradOne, gradTwo);       

end
