function M = randOvercompleteLocalPolytope(K, W)
% randLocalPolytope  Randomly sample from the local polytope at uniform.
%
%   M = randOvercompleteLocalPolytope(K, W) generates K samples from the
%   local polytope whose topology is given by W. Each sample is COLUMN.
%
%   Only structure of W is used.

    % Hardcode; binary pairwise
    N = size(W, 1);
    nEdges = nnz(W) / 2;
    
    D = 2*N + 4*nEdges;

    wtOne = rand(K, N);
    M(D, K) = 0;
    
    for k = 1:K
        one = zeros(2, N);
        one(2,:) = wtOne(k,:);
        two = wtTwoMargs(W, wtOne(k,:));
        M(:,k) = packOvercomplete(one, two);
    end    

end

