%% Load of one David's 10 node graphs
load('trialsComplete10.mat');

T = size(graph, 2);
N   = ref(4, t);
obj = graph(:, t);
G   = make_complete_graph(N, obj);

nEdges = sum(vec(G.Weights ~= 0)) / 2;
degs = sum(G.Weights ~= 0, 1);


% Marginal polytope, random restart
nTrials = 500;
fMins = zeros(nTrials, 1);

for t = 1:nTrials
    try
        mfw = MargBetheFrankWolfe(G.Fields, G.Weights);
        mfw.initKRand(20);
        mfw.plotLine = false;
        [muMin, fMins(t), myHist] = mfw.run();
    catch e
        fMins(t) = NaN;
    end
end

figure; hist(fMins);

minRandRestarts = min(fMins);

fprintf('UNIF - RANDOM STARTS: %g - %g = %g', fMinUnif, minRandRestarts, fMinUnif - minRandRestarts);

