%% Load of one David's 10 node graphs
load('trialsComplete10.mat');

T = size(graph, 2);
N   = ref(4, t);
obj = graph(:, t);
G   = make_complete_graph(N, obj);

nEdges = sum(vec(G.Weights ~= 0)) / 2;
degs = sum(G.Weights ~= 0, 1);

%% Marginal polytope, R random starts
mfw = MargBetheFrankWolfe(G.Fields, G.Weights);
mfw.initUnif();
% figure;
% mfw.initRandWrong();
[muMin, fMinUnif, myHist] = mfw.run();
fMinUnif;


%% Marginal polytope, R random starts

clear mfw;

mfw = MargBetheFrankWolfe(G.Fields, G.Weights);
mfw.initUnif();
% figure;
% mfw.initRandWrong();
[muMin, fMinUnif, myHist] = mfw.run();
fMinUnif;

% Marginal polytope, k-MAP random start
nTrials = 500;
fMins = zeros(nTrials, 1);

diversity = 3;

h = figure;

for r = 1:nTrials
    try
        mfw = MargBetheFrankWolfe(G.Fields, G.Weights);
        mfw.initKRand(20);
%         mfw.initKMAPs(20, 3);
        mfw.ph = h;
        mfw.plotInit = true;        
        [muMin, fMins(r), myHist] = mfw.run();
    catch e
        fMins(r) = NaN;
    end
end

figure; hist(fMins);

minRandRestarts = min(fMins);

fprintf('UNIF - RANDOM STARTS: %g - %g = %g', fMinUnif, minRandRestarts, fMinUnif - minRandRestarts);

