function [muOvercomplete, oneMargs, twoMargs] = wtRandomInitOvercomplete(W)
% wtRandomInitOvercomplete  Sample a stationary point of local polytope
% uniformly.
%
% NOTE: It is not guaranteed that *any* stationary points within tighter
%       polytopes can be generated in this way.

    N = size(W, 1);
    [iVec, ~, ~] = findUT(W);
    nEdges = length(iVec);
    
    unif = rand(1, N);
    [twoMargs, xi] = wtTwoMargs(W, unif);
    
    oneMargs = zeros(2, N);
    oneMargs(2,:) = unif;
    oneMargs(1,:) = 1 - unif;
    
    muOvercomplete = packOvercomplete(oneMargs, twoMargs);
    
    % test
    [oneRecover, twoRecover] = unpackOvercomplete(muOvercomplete, N, nEdges);
    assertElementsAlmostEqual(oneMargs, oneRecover);
    assertElementsAlmostEqual(twoMargs, twoRecover);

end
