function [mu, xi, twoMargs, energy, complexity, exact] = solveMinBethe(theta, W, varargin)
    p = inputParser;

    p.addRequired('theta', @isnumeric);
    p.addRequired('W');
    p.addParamValue('nTrials', 100);    
    p.addParamValue('parallelRestarts', false);
    
    p.parse(theta, W, varargin{:});
    o = p.Results;

    [mu, energy, complexity.muHist, complexity.fHist, complexity.fHistStd] = minBethe(theta, W, varargin{:}); 
    [twoMargs, xi] = wtTwoMargs(W, mu);
    exact = 0;

end
