function [twoMargs, xi] = wtTwoMargs(W, mu)
% [twoMargs, xi] = wtTwoMargs(W, mu) compute pair marginals by Welling-Teh
% in the "find" order
%
%   This twoMargs was the original output format of two marginals; used in
%   particular by the solveDAI.m

    W = triu(W, 1) + triu(W, 1)';
    [iVec, jVec, wVec] = findUT(W);    
    
    N = length(mu);    
    Nedges = length(iVec);        
    
    alpha = exp(W) - 1;
    
    xi       = zeros(N,N);
    twoMargs = zeros(2, 2, Nedges);

    for ii = 1:Nedges
        i = iVec(ii);
        j = jVec(ii);

        [M, xi(i,j)] = marginalize(alpha(i,j), mu(i), mu(j));
        twoMargs(:,:,ii) = reshape(M, 2, 2); % put back for now in case problems with bethe() etc. /AW transposed this 102613 so we now get [v1=0,v2=0 v1=0,v2=1; v1=1,v2=0 v2=1,v2=1]
    end

end

